Subject: Re: [PATCH v2 1/2] arm: lib: xor-neon: remove unnecessary GCC < 4.6 warning

From: Adrian Ratiu <[email-masked]>
Date: Fri, 13 Nov 2020 13:59:48 +0200

On Fri, 13 Nov 2020, Ard Biesheuvel <[email-masked]> wrote:
> On Fri, 13 Nov 2020 at 12:05, Adrian Ratiu 
> <[email-masked]> wrote: 
>> 
>> Hi Ard, 
>> 
>> On Fri, 13 Nov 2020, Ard Biesheuvel <[email-masked]> wrote: 
>> > On Thu, 12 Nov 2020 at 22:23, Adrian Ratiu 
>> > <[email-masked]> wrote: 
>> >> 
>> >> From: Nathan Chancellor <[email-masked]> 
>> >> 
>> >> Drop warning because kernel now requires GCC >= v4.9 after 
>> >> commit 6ec4476ac825 ("Raise gcc version requirement to 
>> >> 4.9"). 
>> >> 
>> >> Reported-by: Nick Desaulniers <[email-masked]> 
>> >> Signed-off-by: Nathan Chancellor <[email-masked]> 
>> >> Signed-off-by: Adrian Ratiu <[email-masked]> 
>> > 
>> > Again, this does not do what it says on the tin. 
>> > 
>> > If you want to disable the pragma for Clang, call that out in 
>> > the commit log, and don't hide it under a GCC version change. 
>> 
>> I am not doing anything for Clang in this series. 
>> 
>> The option to auto-vectorize in Clang is enabled by default but 
>> doesn't work for some reason (likely to do with how it computes 
>> the cost model, so maybe not even a bug at all) and if we 
>> enable it explicitely (eg via a Clang specific pragma) we get 
>> some warnings we currently do not understand, so I am not 
>> changing the Clang behaviour at the recommendation of Nick. 
>> 
>> So this is only for GCC as the "tin" says :) We can fix clang 
>> separately as the Clang bug has always been present and is 
>> unrelated. 
>> 
> 
> But you are adding the IS_GCC check here, no? Is that 
> equivalent? IOW, does Clang today identify as GCC <= 4.6? 
>

I see what you mean now. Thanks.

Clang identifies as GCC <= 4.6 yes, so the code is not strictly 
speaking equivalent. The warning to upgrade GCC doesn't make sense 
for Clang but I should mention removing it in the commit message 
as well.

>> >
>> > Without the pragma, the generated code is the same as the
>> > generic code, so it makes no sense to build xor-neon.ko at all,
>> > right?
>> >
>>
>> Yes that is correct and that is the reason why in v1 I opted to
>> not build xor-neon.ko for Clang anymore, but that got NACKed, so
>> here I'm fixing the low hanging fruit: the very obvious & clear
>> GCC problems.
>>
>>
>
> Fair enough.
>
>> >> ---
>> >>  arch/arm/lib/xor-neon.c | 9 +--------
>> >>  1 file changed, 1 insertion(+), 8 deletions(-)
>> >>
>> >> diff --git a/arch/arm/lib/xor-neon.c b/arch/arm/lib/xor-neon.c
>> >> index b99dd8e1c93f..e1e76186ec23 100644
>> >> --- a/arch/arm/lib/xor-neon.c
>> >> +++ b/arch/arm/lib/xor-neon.c
>> >> @@ -19,15 +19,8 @@ MODULE_LICENSE("GPL");
>> >>   * -ftree-vectorize) to attempt to exploit implicit parallelism and emit
>> >>   * NEON instructions.
>> >>   */
>> >> -#if __GNUC__ > 4 || (__GNUC__ == 4 && __GNUC_MINOR__ >= 6)
>> >> +#ifdef CONFIG_CC_IS_GCC
>> >>  #pragma GCC optimize "tree-vectorize"
>> >> -#else
>> >> -/*
>> >> - * While older versions of GCC do not generate incorrect code, they fail to
>> >> - * recognize the parallel nature of these functions, and emit plain ARM code,
>> >> - * which is known to be slower than the optimized ARM code in asm-arm/xor.h.
>> >> - */
>> >> -#warning This code requires at least version 4.6 of GCC
>> >>  #endif
>> >>
>> >>  #pragma GCC diagnostic ignored "-Wunused-variable"
>> >> --
>> >> 2.29.2
>> >>

_______________________________________________
linux-arm-kernel mailing list
[email-masked]
http://lists.infradead.org/mailman/listinfo/linux-arm-kernel